//+------------------------------------------------------------------+
//|                                              Peak Perfection.mq4 |
//|                                                    Magnus Meseck |
//|                                     magnus.meseck@googlemail.com |
//+------------------------------------------------------------------+
#property copyright "Magnus Meseck"
#property link      "magnus.meseck@googlemail.com"

#property indicator_chart_window
#property indicator_buffers 3

//---- Inputs

extern string ConfigureAMA="The Basic AMA";
extern int       AMAFast=3;
extern int       AMASlow=4;
extern int       AMARange=5;
extern int       AMAFilter=200;
extern string ConfigureSAMA="The Signal AMA";
extern int       SAMAFast=2;
extern int       SAMASlow=20;
extern int       SAMARange=2;
extern int       SAMAFilter=100;
extern string ConfigureATR="The Signal line";
extern int       ATRPeriod=5;
extern int       ATRShift=1;
extern double    AccelerationFactor=2.3;
extern string ConfigureWeighting="Weighting between AMA and SAMA";
extern int       AMAWeight=5;
extern string    to="to";
extern int       SAMAWeight=5;


//---- Buffer Declaration

double   AMA[];
double   Oversold[];
double   Overbought[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- Buffer Number

   IndicatorBuffers(3);

//---- Buffer Initialization

   // Buffer 1
   SetIndexBuffer(0,Overbought);
   SetIndexStyle(0,DRAW_LINE,0,1,Red);
   SetIndexEmptyValue(0,0);   
   // Buffer 2
   SetIndexBuffer(1,AMA);
   SetIndexStyle(1,DRAW_LINE,0,1,LightSteelBlue);
   SetIndexEmptyValue(0,0);
   // Buffer 3
   SetIndexBuffer(2,Oversold);
   SetIndexStyle(2,DRAW_LINE,0,1,Green);
   SetIndexEmptyValue(0,0);
   // Indicator Name
   IndicatorShortName("Peak Perfection");
       
//---- Initialization Complete
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- Calculation Preps  
   
   int   limit,i;
   int   counted_bars=IndicatorCounted();
   
//---- Checking for Errors/defining limit

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
//----!!Attention!! Serious Mathematics ahead!! *Just Joking* ;D

   //---- Calculating upper Indicator Line. Value 5000 (below) is the amount of bars for the Indi to Calculate...nothing to worry about
   for(i=0;i<limit;i++)       
      {
      Overbought[i]=(iCustom(NULL,0,"AMA_STL",AMAFast,AMASlow,AMARange,AMAFilter,5000,0,i+1)*AMAWeight
                     +
                     iCustom(NULL,0,"AMA_STL",SAMAFast,SAMASlow,SAMARange,SAMAFilter,5000,0,i+1)*SAMAWeight)
                     /
                     (SAMAWeight+AMAWeight)
                     +
                     iATR(NULL,0,ATRPeriod,i+ATRShift)*AccelerationFactor;
      }
   //---- Displaying original AMA Line
   for(i=0;i<limit;i++)       
      {               
      AMA[i]=iCustom(NULL,0,"AMA_STL",AMAFast,AMASlow,AMARange,AMAFilter,5000,0,i+1);
      }
   //----   Calculating lower Indicator Line
   for(i=0;i<limit;i++)       
      {   
      Oversold[i]=(iCustom(NULL,0,"AMA_STL",AMAFast,AMASlow,AMARange,AMAFilter,5000,0,i+1)*AMAWeight
                  +
                  iCustom(NULL,0,"AMA_STL",SAMAFast,SAMASlow,SAMARange,SAMAFilter,5000,0,i+1)*SAMAWeight)
                  /
                  (SAMAWeight+AMAWeight)
                  -
                  iATR(NULL,0,ATRPeriod,i+ATRShift)*AccelerationFactor; 
      }
//---- All calculations complete!      
   return(0);
  }
//+------------------------------------------------------------------+